#define	AX_UILIFE	(5*60*2)	/* hang on to UI ccbs for 5 mins */

struct ax_ccb {
	struct ax_addr	mycall;
	struct ax_addr	hiscall;
	struct ax_ccb	*ax_ccbnext;	/* forward pointer */
	struct ax_ccb	*ax_ccbprev;	/* backward pointer */
	struct ax_ccb	*ax_ccbhead;	/* head of ccb chain */
	struct socket	*ax_socket;	/* pointer back to socket */
	struct ax_hdr	*rxhdr;		/* most recent rec'd packet hdr */
	struct mbuf	*rxq;		/* incoming data */
	struct mbuf	*txq;		/* outgoing data */
	struct mbuf	*txp[8];	/* unack'ed output packets */
	u_char	mode;		/* raw, dgram, stream */
	u_char	state;		/* state-machine state for this conn. */
	u_char	vr;		/* receive seq number */
	u_char	vs;		/* send seq number */
	u_char	nr;		/* incoming receive seq number */
	u_char	ns;		/* incoming send seq number */
	u_char	frmr;		/* what caused most recent FRMR (bits) */
	u_char	t1;		/* ack timer */
	u_char	t2;		/* response delay timer */
	short	t3;		/* inactive link timer (keepalives) */
	u_char	k;		/* number of unack'd I-frames */
	u_char	n2;		/* number of retries */
	u_char	maxframe;	/* limit (1-7) of unack'd packets */
	u_char	retries;	/* retry limit */
	u_char	frack;		/* response time */
	u_char	resptime;	/* send-ack delay time */
	short	paclen;		/* max data field length */
	short	keepalive;	/* idle time */
};

struct	axdstat {
				/* input statistics: */
	int	axds_ipackets;		/* total input packets */
	int	axds_hdrops;		/* packet shorter than header */
	int	axds_badsum;		/* checksum error */
	int	axds_badlen;		/* data length larger than packet */
	int	axds_fullsock;		/* not delivered, input socket full */
	int	axdps_pcbcachemiss;	/* input packets missing pcb cache */
				/* output statistics: */
	int	axds_opackets;		/* total output packets */
};

struct	axsstat {
	u_long	axss_connattempt;	/* connections initiated */
	u_long	axss_accepts;		/* connections accepted */
	u_long	axss_connects;		/* connections established */
	u_long	axss_drops;		/* connections dropped */
	u_long	axss_conndrops;		/* embryonic connections dropped */
	u_long	axss_closed;		/* conn. closed (includes drops) */
	u_long	axss_segstimed;		/* segs where we tried to get rtt */
	u_long	axss_rttupdated;	/* times we succeeded */
	u_long	axss_delack;		/* delayed acks sent */
	u_long	axss_timeoutdrop;	/* conn. dropped in rxmt timeout */
	u_long	axss_rexmttimeo;	/* retransmit timeouts */
	u_long	axss_persisttimeo;	/* persist timeouts */
	u_long	axss_keeptimeo;		/* keepalive timeouts */
	u_long	axss_keepprobe;		/* keepalive probes sent */
	u_long	axss_keepdrops;		/* connections dropped in keepalive */

	u_long	axss_sndtotal;		/* total packets sent */
	u_long	axss_sndpack;		/* data packets sent */
	u_long	axss_sndbyte;		/* data bytes sent */
	u_long	axss_sndrexmitpack;	/* data packets retransmitted */
	u_long	axss_sndrexmitbyte;	/* data bytes retransmitted */
	u_long	axss_sndacks;		/* ack-only packets sent */
	u_long	axss_sndprobe;		/* window probes sent */
	u_long	axss_sndurg;		/* packets sent with URG only */
	u_long	axss_sndwinup;		/* window update-only packets sent */
	u_long	axss_sndctrl;		/* control packets sent */

	u_long	axss_rcvtotal;		/* total packets received */
	u_long	axss_rcvpack;		/* packets received in sequence */
	u_long	axss_rcvbyte;		/* bytes received in sequence */
	u_long	axss_rcvbadsum;		/* packets received with ccksum errs */
	u_long	axss_rcvbadoff;		/* packets received with bad offset */
	u_long	axss_rcvshort;		/* packets received too short */
	u_long	axss_rcvduppack;	/* duplicate-only packets received */
	u_long	axss_rcvdupbyte;	/* duplicate-only bytes received */
	u_long	axss_rcvpartduppack;	/* packets with some duplicate data */
	u_long	axss_rcvpartdupbyte;	/* dup. bytes in part-dup. packets */
	u_long	axss_rcvoopack;		/* out-of-order packets received */
	u_long	axss_rcvoobyte;		/* out-of-order bytes received */
	u_long	axss_rcvpackafterwin;	/* packets with data after window */
	u_long	axss_rcvbyteafterwin;	/* bytes rcvd after window */
	u_long	axss_rcvafterclose;	/* packets rcvd after "close" */
	u_long	axss_rcvwinprobe;	/* rcvd window probe packets */
	u_long	axss_rcvdupack;		/* rcvd duplicate acks */
	u_long	axss_rcvacktoomuch;	/* rcvd acks for unsent data */
	u_long	axss_rcvackpack;	/* rcvd ack packets */
	u_long	axss_rcvackbyte;	/* bytes acked by rcvd acks */
	u_long	axss_rcvwinupd;		/* rcvd window update packets */
};

#ifdef KERNEL
struct	axstat	axstat;
struct	axdstat	axdstat;
struct	axsstat	axsstat;
struct	ax_ifaddr *ax_ifaddr;
struct	ax_ifaddr *ax_iaonnetof();
struct	ifqueue	axintrq;		/* ax25 packet input queue */
struct	ax_addr	ax_bcast;
struct	ax_ccb	axb;			/* head of CCB queue */
#endif
