/*
 * AX.25 Address Resolution Protocol.
 *
 * See RFC 826 for protocol description.  Structure below is adapted
 * to resolving AX25 addresses.  Field names used correspond to RFC 826.
 */
struct	ax25_arp {
	struct	arphdr ea_hdr;		/* fixed-size header */
	struct	ax_addr arp_shwa;	/* sender hardware address */
	u_char	arp_spa[4];		/* sender protocol address */
	struct	ax_addr arp_thwa;	/* target hardware address */
	u_char	arp_tpa[4];		/* target protocol address */
};

/*
 * Structure shared between the ax25 driver modules and
 * the address resolution code.  For example, each xx_softc
 * begins with this structure.
 */
struct	ax_arpcom {
	struct 	ifnet ac_if;		/* network-visible interface */
	struct	ax_addr hwa;		/* ax25 media-level address */
	struct in_addr ac_ipaddr;	/* copy of ip address- XXX */
};

/*
 * Internet to ax25 address resolution table.
 */
struct	ax_arptab {
	struct	in_addr at_iaddr;	/* internet address */
	struct	ax_addr axaddr;		/* media-level address */
	u_char	at_timer;		/* minutes since last reference */
	u_char	at_flags;		/* flags */
	struct	mbuf *at_hold;		/* last packet until resolved/timeout */
};

#ifdef	KERNEL
struct	arptab *arptnew();
int	ax_input(), ax_output();
char	*ether_sprintf();
#endif
